package com.school.project.controller;

import com.school.project.model.Teacher;
import com.school.project.service.TeacherService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Optional;

@RestController
public class TeacherController {

    @Autowired
    public TeacherService teacherService;

    @PostMapping("/teacher")
    public Teacher saveTeacher(@RequestBody Teacher teacher){
        return teacherService.saveTeacher(teacher);
    }

    @GetMapping("/teachers")
    public List<Teacher> readAllTeachers(){
        return (List<Teacher>) teacherService.readAllTeachers();
    }

    @GetMapping("teacher/{id}")
    public Optional<Teacher> readTeacherById(@PathVariable("id") Long id){
        return teacherService.readTeacherById(id);
    }

    @PutMapping("teacher/{id}")
    public Teacher updateTeacherById(@RequestBody Teacher teacher,@PathVariable("id") Long id){
        return teacherService.updateTeacher(teacher,id);
    }

    @DeleteMapping("teacher/{id}")
    public void deleteTeacherById(@PathVariable("id") Long id){
        teacherService.deleteTeacherById(id);
    }

}
